/**********************************************
*
*  Elate Winease header file
*  Version 0.30
*
*  Written by: Patrick Roberts
*              amiga@artixsoft.com
*
*  With much thanks to:
*
*       Vesa Tuomiaro, and the Tao 'togrey' author.
*
*/



#include <elate/taort.h>
#include <elate/ave.h>
#include <elate/kn.h>
#include <elate/grf.h>
#include <elate/devices.h>
#include <strings.h>

// MISSING AVE-AVO PROTOS

#ifndef NO_AVE_PROTOS

extern void *ave_avo_pix_1bit_open(ELATE_OO_DATA *,int , int , int ) __attribute__
((
	"qcall ave/avo/pix/1bit/open"
));

extern void *ave_avo_pix_4bit_open(ELATE_OO_DATA *,int , int , int ) __attribute__
((
	"qcall ave/avo/pix/4bit/open"
));

extern void *ave_avo_pix_8bit_open(ELATE_OO_DATA *,int , int , int ) __attribute__
((
	"qcall ave/avo/pix/8bit/open"
));

extern void *ave_avo_pix_12bit_open(ELATE_OO_DATA *,int , int , int ) __attribute__
((
	"qcall ave/avo/pix/12bit/open"
));

extern void *ave_avo_pix_15bit_open(ELATE_OO_DATA *,int , int , int ) __attribute__
((
	"qcall ave/avo/pix/15bit/open"
));

extern void *ave_avo_pix_16bit_open(ELATE_OO_DATA *,int , int , int ) __attribute__
((
	"qcall ave/avo/pix/16bit/open"
));

extern void *ave_avo_pix_24bit_open(ELATE_OO_DATA *,int , int , int ) __attribute__
((
	"qcall ave/avo/pix/24bit/open"
));

extern void *ave_avo_pix_32bit_open(ELATE_OO_DATA *,int , int , int ) __attribute__
((
	"qcall ave/avo/pix/32bit/open"
));

extern void *ave_avo_img_filled_open(int , int , int ) __attribute__
((
	"qcall ave/avo/img/filled/open"
));

extern void *ave_avo_img_tiled_open(int , int , int ) __attribute__
((
	"qcall ave/avo/img/tiled/open"
));

extern void *ave_avo_img_htrans_open(int , int , int ) __attribute__
((
	"qcall ave/avo/img/htrans/open"
));

extern void *ave_avo_img_rgbmask_open(int , int , int ) __attribute__
((
	"qcall ave/avo/img/rgbmask/open"
));

extern void *ave_avo_img_togrey_open(int , int , int ) __attribute__
((
	"qcall ave/avo/img/togrey/open"
));

extern void *ave_avo_img_vgrad_open(int , int , int ) __attribute__
((
	"qcall ave/avo/img/vgrad/open"
));


extern void *ave_font_open() __attribute__
((
	"qcall ave/font/open"
));

extern void *ave_font_getfm() __attribute__
((
	"qcall ave/font/getfm"
));

extern void *ave_font_losefm(void *) __attribute__
((
	"qcall ave/font/losefm"
));

extern void ave_font_strprintu(void *, void *, char *, int, int, int, int, int) __attribute__
((
	"ncall strprintu"
));

extern int ave_font_start(void *) __attribute__
((
	"ncall start"
));

extern void ave_font_finish(void *) __attribute__
((
	"ncall finish"
));


extern int ave_avo_pix_pick(void *,int , int) __attribute__
((
	"ncall pick"
));

extern void ave_avo_pix_plot(void *,int , int , int ) __attribute__
((
	"ncall plot"
));

extern void ave_avo_pix_aplot(void *,int , int , int ) __attribute__
((
	"ncall aplot"
));

extern void ave_avo_pix_xplot(void *,int , int , int ) __attribute__
((
	"ncall xplot"
));

extern void ave_avo_pix_box_new(ELATE_OO_DATA *, int , int , int , int , int ) __attribute__
((
	"ncall box"
));

extern void ave_avo_pix_fbox_new(ELATE_OO_DATA *, int , int , int , int , int ) __attribute__
((
	"ncall fbox"
));

extern void ave_avo_pix_line_new(ELATE_OO_DATA *, int , int , int , int , int ) __attribute__
((
	"ncall line"
));

extern void ave_avo_pix_oval_new(ELATE_OO_DATA *, int , int , int , int , int ) __attribute__
((
	"ncall oval"
));

extern void ave_avo_pix_foval_new(ELATE_OO_DATA *, int , int , int , int , int ) __attribute__
((
	"ncall foval"
));

extern void ave_avo_pix_arc_new(ELATE_OO_DATA *, int , int , int , int , int , int , int ) __attribute__
((
	"ncall arc"
));

extern void ave_avo_pix_fpoly_new(ELATE_OO_DATA *, void *, void *, int , int , int , int ) __attribute__
((
	"ncall fpoly"
));

#else

  #define ave_avo_pix_fbox_new ave_avo_pix_fbox

  #define ave_avo_pix_box_new ave_avo_pix_box

  #define ave_avo_pix_line_new ave_avo_pix_line 

  #define ave_avo_pix_oval_new ave_avo_pix_oval 

  #define ave_avo_pix_foval_new ave_avo_pix_foval 

  #define ave_avo_pix_arc_new ave_avo_pix_arc 

  #define ave_avo_pix_fpoly_new ave_avo_fpoly_arc 

#endif


#define _EWE_FOREVER -1
#define __EWE_MAXAVEEVENTS 16
#define _EWE_EV_TIMEOUT -1
#define _EWE_NO_ROUTINE NULL
#define _EWE_EVENT_LOOP 1
#define _EWE_EVENT_DISABLE -1
#define _EWE_EVENT_RETURN 0
#define _EWE_EVENT_NO_RETURN 1


char __EWE_AVE_INIT=0;
void (*__EWE_EVENTPTRS[__EWE_MAXAVEEVENTS])(ave_avo_app_getevent_t) = {NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
int  __EWE_EVENTPTRSloop[__EWE_MAXAVEEVENTS] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
void (*__EWE_EVENTPTRidle)()=NULL;
int  __EWE_EVENTidleLOOP=0;
char _EWE_EVENT_DEBUG=0;

struct __EWE_INITPTRS {
	   ELATE_OO_DATA *aveinst, *app, *toolkit, *props;
	   char *argv0;
	} __EWE_INITPTRS;

struct __EWE_KEYBOARD {
	ELATE_OO_DATA *kdev;
	ELATE_OO_DATA *khdl;
	char *devname;
	} __EWE_KEYBOARD = {NULL, NULL, NULL};


/* PROTOTYPES */

void *ewe_openWindow(char *, int, int, int);
void  ewe_initAVE();
void  ewe_shutdownAVE();
void  ewe_showWindow(void *);
int   ewe_addEvent(int, void*, void*, int);
int   ewe_eventLoop(void *,long);
int   ewe_disableEvent(int);
int   ewe_enableEvent(int);
void  ewe_refreshWindow(void *);
void  ewe_debug_event_signal(ave_avo_app_getevent_t);
int   ewe_useKeyboard(int);

/* SIMPLE ROUTINES AS MACROS FOR FASTER SPEED*/

#define  ewe_init() __EWE_INITPTRS.argv0=argv[0]

#define  ewe_eventLMB(a) ((a.eventmsg->EVD_BUTTONS) == 1 ? 1 : 0 )
#define  ewe_eventMMB(a) ((a.eventmsg->EVD_BUTTONS) == 4 ? 1 : 0 )
#define  ewe_eventRMB(a) ((a.eventmsg->EVD_BUTTONS) == 2 ? 1 : 0 )

#define  ewe_eventLocalXcoord(a) ((a.eventmsg->EVD_RX))
#define  ewe_eventLocalYcoord(a) ((a.eventmsg->EVD_RY))

#define  ewe_eventGlobalXcoord(a) ((a.eventmsg->EVD_X))
#define  ewe_eventGlobalYcoord(a) ((a.eventmsg->EVD_Y))

#define ewe_showWindow(a) (ave_avo_update(a))
#define ewe_refreshWindow(a) (ave_avo_update(a))


void ewe_initAVE() {

   
   char *cp1, buf[256] = "/device/ave/";
   
   __EWE_INITPTRS.aveinst=__EWE_INITPTRS.app=__EWE_INITPTRS.toolkit=NULL;
   
   cp1=strrchr(__EWE_INITPTRS.argv0,'/')+1;
   if(cp1==NULL)cp1=__EWE_INITPTRS.argv0;
   strcat(buf,cp1);

   kn_dev_lookup(buf, &__EWE_INITPTRS.aveinst, &__EWE_INITPTRS.argv0);
   __EWE_INITPTRS.app = ave_open(__EWE_INITPTRS.aveinst, __EWE_INITPTRS.argv0, 0, 0);

 //  ave_avo_app_getprop(__EWE_INITPTRS.app);
system("sleep 1"); // TEMP UNTIL I FIGURE OUT HOW TO CHECK OPEN COMPLETE STATUS

   __EWE_INITPTRS.toolkit = ave_opentoolkit(__EWE_INITPTRS.aveinst);
   __EWE_INITPTRS.props = ave_avo_app_getprop(__EWE_INITPTRS.app);

   __EWE_AVE_INIT=1;

}

void ewe_shutdownAVE() {

   if(__EWE_AVE_INIT) {
      ave_closetoolkit(__EWE_INITPTRS.aveinst,__EWE_INITPTRS.toolkit);
      ave_close(__EWE_INITPTRS.aveinst,__EWE_INITPTRS.app);
   }
   if(__EWE_KEYBOARD.khdl!=NULL) {
	dev_close(__EWE_KEYBOARD.kdev,__EWE_KEYBOARD.khdl);   
   }

}

void *ewe_openWindow(char *title, int sizeX, int sizeY, int flags) {
  
  void *win=NULL;
  void *pix;

  if(!__EWE_AVE_INIT) ewe_initAVE();
  
  win=ave_toolkit_createdialog(
   	__EWE_INITPTRS.toolkit,
	__EWE_INITPTRS.props,
	title,
	NULL,
	sizeX,
	sizeY,
	flags);

  ave_avo_addlink(win, __EWE_INITPTRS.app, CH_DIALOG_ACTION, EV_USER);
  ave_avo_app_add(__EWE_INITPTRS.app, win, 0);

return win;
}


int ewe_eventLoop(void *win, long nsTimeout) {

   ave_avo_app_getevent_t eventIN;

__ewe_eventloop:

   eventIN.targetavo = NULL;
   eventIN.eventmsg = NULL;
   eventIN.eventtype = 0;

   if(nsTimeout == _EWE_FOREVER) {
      while(!eventIN.targetavo) eventIN = ave_avo_app_getevent(__EWE_INITPTRS.app, nsTimeout);
      ave_avo_event(eventIN.targetavo, eventIN.eventmsg, eventIN.eventtype);
	}
   else 
      eventIN = ave_avo_app_getevent(__EWE_INITPTRS.app, nsTimeout);
      
   if(_EWE_EVENT_DEBUG) ewe_debug_event_signal(eventIN);

   if(eventIN.eventtype != 0 &&  eventIN.targetavo != NULL) {
      ave_freeevent(eventIN.targetavo, eventIN.eventmsg);
   }
   
   /* HANDLE USER ISOLATED REQUESTS - UNDER CONSTRUCTION*/
/*   
   if(eventIN.eventmsg.EVD_DATA == DI_MIN) {
										;min app
										ncall win,getminsize,(win:nw,nh)
										ncall win,getpos,(win:nx,ny,i~)
										go pingpong
   if(eventIN.eventmsg.EVD_DATA == DI_MAX) {
									case action=DI_MAX
										;max app
										ncall ave,aveinfo,(ave:nw,nh,i~,i~,i~)
										clr nx
										clr ny
									pingpong:
										ncall win,getpos,(win:x,y,i~)
										ncall win,getsize,(win:w,h)
										if ((w eq nw)&&(h eq nh))
											cpy ox,x
											cpy oy,y
											cpy ow,w
											cpy oh,h
										else
											cpy x,ox
											cpy y,oy
											cpy w,ow
											cpy h,oh
											cpy nx,x
											cpy ny,y
											cpy nw,w
											cpy nh,h
										endif
										ncall win,change,(win,x,y,w,h,CM_ADD:-)
*/
   
   /* HANDLE USER'S CALLBACK EVENTS */

   if(__EWE_EVENTPTRSloop[eventIN.eventtype]==-1 || (eventIN.eventtype >= 8192 && eventIN.eventtype < 16384)) goto __ewe_eventloop;

   if(eventIN.eventtype == 0 && eventIN.targetavo == NULL && __EWE_EVENTPTRidle !=NULL )
   {
      __EWE_EVENTPTRidle();
      if(__EWE_EVENTidleLOOP) goto __ewe_eventloop;
   }
   else if (eventIN.eventtype <= __EWE_MAXAVEEVENTS && eventIN.targetavo!=NULL ) {
      if(__EWE_EVENTPTRS[eventIN.eventtype]!=NULL) {
   	  __EWE_EVENTPTRS[eventIN.eventtype](eventIN);
          if (__EWE_EVENTPTRSloop[eventIN.eventtype]==1) goto __ewe_eventloop;
      }
    }
        
return eventIN.eventtype;

}

int ewe_addEvent(int event, void *win, void *addr, int loop) {

	if(event==_EWE_EV_TIMEOUT) {
	   __EWE_EVENTPTRidle = addr;
	   __EWE_EVENTidleLOOP = loop;
	} else
	 if(event <= __EWE_MAXAVEEVENTS) {
	   ave_avo_addlink(win, __EWE_INITPTRS.app, CH_DIALOG_ACTION, event);
	   __EWE_EVENTPTRS[event]= addr;
	   __EWE_EVENTPTRSloop[event]=loop;
	} else {
	   return 1;
	}

return 0;
}

int ewe_disableEvent(int event) {

	 if(event <= __EWE_MAXAVEEVENTS) {
	   __EWE_EVENTPTRS[event]= NULL;
	   __EWE_EVENTPTRSloop[event]=-1;
	} else {
	   return 1;
	}

return 0;
}

int ewe_enableEvent(int event) {

	 if(event <= __EWE_MAXAVEEVENTS) {
	   __EWE_EVENTPTRS[event]= NULL;
	   __EWE_EVENTPTRSloop[event]=0;
	} else {
	   return 1;
	}

return 0;
}

void  ewe_debug_event_signal(ave_avo_app_getevent_t eventp) {

   ELATE_EVD *event;

   event=eventp.eventmsg;
   
   printf("\nEvent received:\n");
   printf("\tEVD_TYPE: %d\n",event->EVD_TYPE);
   printf("\tEVD_TIMESTAMP: %d\n",event->EVD_TIMESTAMP);
   printf("\tEVD_TARGET: 0x%x\n",event->EVD_TARGET);
   printf("\tEVD_TARGETID: %d\n",event->EVD_TARGETID);
   printf("\tEVD_SOURCE: 0x%x\n",event->EVD_SOURCE);
   printf("\tEVD_SOURCEID: %d\n",event->EVD_SOURCEID);
   printf("\tEVD_CHANNEL: %d\n",event->EVD_CHANNEL);
   printf("\tEVD_X: %d\n",event->EVD_X);
   printf("\tEVD_Y: %d\n",event->EVD_Y);
   printf("\tEVD_RX: %d\n",event->EVD_RX);
   printf("\tEVD_RY: %d\n",event->EVD_RY);
   printf("\tEVD_BUTTONS: %d\n",event->EVD_BUTTONS);
   printf("\tEVD_COUNT: %d\n",event->EVD_COUNT);
   printf("\tEVD_KEY: %d\n",event->EVD_KEY);
   printf("\tEVD_KEYSTATE: %d\n",event->EVD_KEYSTATE);
   printf("\tEVD_KEYCOOKED: %d\n",event->EVD_KEYCOOKED);
   printf("\tEVD_TOKEN: %d\n",event->EVD_TOKEN);
   printf("\tEVD_DATA: %x\n",event->EVD_DATA);
   fflush(stdout);
}

int ewe_useKeyboard(int flags) {

     char *cp1, *buf = "/device/keyboard";
      
   kn_dev_lookup(buf, &__EWE_KEYBOARD.kdev , &__EWE_KEYBOARD.devname);
   __EWE_KEYBOARD.khdl = dev_open(__EWE_KEYBOARD.kdev, __EWE_KEYBOARD.devname, flags, 0);


}


/* BASIC WINDOWS */

int ewe_simple2BRequest(char *title, int winflags, char *text, char *fontname, int fontsize, int fontcolor, int papercolor, char *button1, char *button2) {


  void *swin, *font, *fontlib, *textfld;
  ave_avo_win_std_dialog_getgadgets_t gdg;
    
   swin = ewe_openWindow(title,100,50,winflags);
   
   
   /* INITIALIZE FONT SUB_SYSTEM */

   fontlib=ave_font_getfm();
   font=ave_font_open(fontname ,fontsize , 1);
   ave_font_losefm(fontlib); 

   textfld = ave_avo_pix_8bit_open(NULL,100,50,100);
   ave_avo_pix_fbox_new(textfld,0,0,papercolor,100,50); 
   
   ave_font_strprintu(font, textfld, text, 0,0,fontcolor,papercolor,3);
   
   gdg = ave_avo_win_std_dialog_getgadgets(swin);
   ave_avo_add(gdg.content, textfld, 0);
 
   ave_avo_addlink(swin, __EWE_INITPTRS.app, CH_DIALOG_ACTION, EV_BUTTONDOWN);

   ewe_showWindow(swin);
    
  
}

